commit bdb65dd6fd1af3f7d186adc05bfe27f11b1403d4
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Mon Jan 19 14:52:58 2026 +0000

    Debug: add "macro" channel

diff --git a/src/src/buildconfig.c b/src/src/buildconfig.c
index b365643bb..081d1041b 100644
--- a/src/src/buildconfig.c
+++ b/src/src/buildconfig.c
@@ -207,6 +207,9 @@ else
   fprintf(new, "#define SSIZE_T_FMT  \"%%d\"\n");
 #endif
 
+fprintf(new, "#define EXIM_ULONG_BITS	%u\n",
+		sizeof(unsigned long) == 8 ? 64 : 32);
+
 /* Now search the makefile for certain settings */
 
 if (!(base = fopen("Makefile", "rb")))
diff --git a/src/src/daemon.c b/src/src/daemon.c
index e8432196c..a37cc7cc6 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -188,7 +188,7 @@ pid_t pid;
 union sockaddr_46 interface_sockaddr;
 EXIM_SOCKLEN_T ifsize = sizeof(interface_sockaddr);
 int max_for_this_host = 0;
-int save_log_selector = *log_selector;
+unsigned long save_log_selector = *log_selector;
 gstring * whofrom;
 
 rmark reset_point = store_mark();
diff --git a/src/src/exim.c b/src/src/exim.c
index 7e90e927c..e11250cc0 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -2822,7 +2822,7 @@ on the second character (the one after '-'), to save some effort. */
       /* Use an intermediate variable so that we don't set debugging while
       decoding the debugging bits. */
 
-      unsigned int selector = D_default;
+      unsigned long selector = D_default;
       debug_selector = 0;
       debug_file = NULL;
       if (*argrest == 'd')
diff --git a/src/src/exim_dbmbuild.c b/src/src/exim_dbmbuild.c
index 8cb06fefe..c6c884125 100644
--- a/src/src/exim_dbmbuild.c
+++ b/src/src/exim_dbmbuild.c
@@ -77,7 +77,7 @@ const uschar * parse_find_address_end_gen(const uschar * s, BOOL b)
 
 
 struct global_flags	f;
-unsigned int		log_selector[1];
+unsigned long		log_selector[1];
 uschar *		queue_name;
 BOOL			split_spool_directory;
 
@@ -98,7 +98,7 @@ const uschar *hex_digits = CUS"0123456789abcdef";
 *   Debug output   *
 *******************/
 
-unsigned int debug_selector = 0;	/* set -1 for debugging */
+unsigned long debug_selector = 0;	/* set -1 for debugging */
 
 void
 debug_printf(const char * fmt, ...)
diff --git a/src/src/exim_dbutil.c b/src/src/exim_dbutil.c
index b6977513b..2955861fa 100644
--- a/src/src/exim_dbutil.c
+++ b/src/src/exim_dbutil.c
@@ -65,7 +65,7 @@ const uschar * parse_find_address_end_gen(const uschar * s, BOOL b)
 {return NULL; }
 
 struct global_flags	f;
-unsigned int		log_selector[1];
+unsigned long		log_selector[1];
 uschar *		queue_name;
 BOOL			split_spool_directory;
 
@@ -113,7 +113,7 @@ exit(EXIT_FAILURE);
 *   Debug output   *
 *******************/
 
-unsigned int debug_selector = 0;	/* set -1 for debugging */
+unsigned long debug_selector = 0;	/* set -1 for debugging */
 
 void
 debug_printf(const char * fmt, ...)
diff --git a/src/src/functions.h b/src/src/functions.h
index 9d4201a7b..677972e01 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -139,8 +139,8 @@ extern BOOL    bdat_hasc(void);
 extern int     bdat_ungetc(int);
 extern void    bdat_flush_data(void);
 
-extern void    bits_clear(unsigned int *, size_t, int *);
-extern void    bits_set(unsigned int *, size_t, int *);
+extern void    bits_clear(unsigned long *, size_t, int *);
+extern void    bits_set(unsigned long *, size_t, int *);
 
 extern void    cancel_cutthrough_connection(BOOL, const uschar *);
 extern gstring *cat_file(FILE *, gstring *, const uschar *);
@@ -188,7 +188,7 @@ extern void    debug_pretrigger_discard(void);
 extern void    debug_print_socket(int);
 extern void    debug_trigger_fire(void);
 
-extern void    decode_bits(unsigned int *, size_t, int *,
+extern void    decode_bits(unsigned long *, size_t, int *,
 	           const uschar *, bit_table *, int, uschar *, int);
 extern void    delete_pid_file(void);
 extern void    deliver_local(address_item *, BOOL);
diff --git a/src/src/globals.c b/src/src/globals.c
index 2b2270899..90906e923 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -657,6 +657,7 @@ FILE   *debug_file             = NULL;
 int     debug_notall[]         = {
   Di_memory,
   Di_noutf8,
+  Di_macro,
   -1
 };
 bit_table debug_options[]      = { /* must be in alphabetical order and use
@@ -678,6 +679,7 @@ bit_table debug_options[]      = { /* must be in alphabetical order and use
   BIT_TABLE(D, load),
   BIT_TABLE(D, local_scan),
   BIT_TABLE(D, lookup),
+  BIT_TABLE(D, macro),
   BIT_TABLE(D, memory),
   BIT_TABLE(D, noutf8),
   BIT_TABLE(D, pid),
@@ -698,7 +700,7 @@ int      debug_options_count	= nelem(debug_options);
 uschar   debuglog_name[LOG_NAME_SIZE] = {0};
 unsigned debug_pretrigger_bsize	= 0;
 uschar * debug_pretrigger_buf	= NULL;
-unsigned int debug_selector	= 0;
+unsigned long debug_selector	= 0;
 BOOL	 debug_startup		= FALSE;
 
 int     delay_warning[DELAY_WARNING_SIZE] = { DELAY_WARNING_SIZE, 1, 24*60*60 };
@@ -1013,7 +1015,7 @@ int     log_options_count      = nelem(log_options);
 
 const uschar *log_ports	       = NULL;
 int     log_reject_target      = 0;
-unsigned int log_selector[log_selector_size]; /* initialized in main() */
+unsigned long log_selector[log_selector_size]; /* initialized in main() */
 uschar *log_selector_string    = NULL;
 FILE   *log_stderr             = NULL;
 uschar *login_sender_address   = NULL;
diff --git a/src/src/globals.h b/src/src/globals.h
index befaf308b..5402fb59e 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -673,7 +673,7 @@ extern int     log_notall[];           /* Log options excluded from +all */
 extern bit_table log_options[];        /* Table of options */
 extern int     log_options_count;      /* Size of table */
 extern int     log_reject_target;      /* Target log for ACL rejections */
-extern unsigned int log_selector[];    /* Bit map of logging options */
+extern unsigned long log_selector[];   /* Bit map of logging options */
 extern uschar *log_selector_string;    /* As supplied in the config */
 extern FILE   *log_stderr;             /* Copy of stderr for log use, or NULL */
 extern BOOL    log_timezone;           /* TRUE to include the timezone in log lines */
diff --git a/src/src/local_scan.h b/src/src/local_scan.h
index c9d179375..6e63672eb 100644
--- a/src/src/local_scan.h
+++ b/src/src/local_scan.h
@@ -44,7 +44,7 @@ each time a new feature is added (in a way that doesn't break backward
 compatibility). */
 
 #define LOCAL_SCAN_ABI_VERSION_MAJOR 7
-#define LOCAL_SCAN_ABI_VERSION_MINOR 0
+#define LOCAL_SCAN_ABI_VERSION_MINOR 1
 #define LOCAL_SCAN_ABI_VERSION \
   LOCAL_SCAN_ABI_VERSION_MAJOR.LOCAL_SCAN_ABI_VERSION_MINOR
 
@@ -165,7 +165,7 @@ typedef struct recipient_item {
 
 /* Global variables that are documented as visible in the function. */
 
-extern unsigned int debug_selector;    /* Debugging bits */
+extern unsigned long debug_selector;   /* Debugging bits */
 
 extern int     body_linecount;         /* Line count in body */
 extern int     body_zerocount;         /* Binary zero count in body */
diff --git a/src/src/log.c b/src/src/log.c
index 40bdfcd0c..0220b91bb 100644
--- a/src/src/log.c
+++ b/src/src/log.c
@@ -1366,14 +1366,14 @@ Arguments:
 */
 
 void
-bits_clear(unsigned int *selector, size_t selsize, int *bits)
+bits_clear(unsigned long * selector, size_t selsize, int * bits)
 {
 for(; *bits != -1; ++bits)
   BIT_CLEAR(selector, selsize, *bits);
 }
 
 void
-bits_set(unsigned int *selector, size_t selsize, int *bits)
+bits_set(unsigned long * selector, size_t selsize, int * bits)
 {
 for(; *bits != -1; ++bits)
   BIT_SET(selector, selsize, *bits);
@@ -1403,7 +1403,7 @@ we treat it as an unknown option: error message to stderr and die.
 Arguments:
   selector       address of the bit string
   selsize        number of words in the bit string
-  notall         list of bits to exclude from "all"
+  notall         list of bit-numbers to exclude from "all"
   string         the configured string
   options        the table of option names
   count          size of table
@@ -1414,11 +1414,12 @@ Returns:         nothing on success - bomb out on failure
 */
 
 void
-decode_bits(unsigned int * selector, size_t selsize, int * notall,
+decode_bits(unsigned long * selector, size_t selsize, int * notall,
   const uschar * string, bit_table * options, int count, uschar * which,
   int flags)
 {
-uschar *errmsg;
+uschar * errmsg;
+
 if (!string) return;
 
 if (*string == '=')
diff --git a/src/src/macros.h b/src/src/macros.h
index f6b240322..a1a9cd6c1 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -101,7 +101,7 @@ don't make the file descriptors two-way. */
 /* Debugging control */
 
 #define LOG_NAME_SIZE 256
-#define IS_DEBUG(x)	(debug_selector & (x))
+#define IS_DEBUG(x)	(debug_selector & (x ? x : D_any))
 #define DEBUG(x)	if (IS_DEBUG(x))
 #define HDEBUG(x)	if (host_checking || IS_DEBUG(x))
 
@@ -327,17 +327,21 @@ for having to swallow the rest of an SMTP message is whether the value is
 
 /* Bit masks for debug and log selectors */
 
-/* Assume words are 32 bits wide. Tiny waste of space on 64 bit
+/* Assume words are at least 32 bits wide. Tiny waste of space on 64 bit
 platforms, but this ensures bit vectors always work the same way. */
-#define BITWORDSIZE 32
+#ifdef EXIM_ULONG_BITS
+  #define BITWORDSIZE EXIM_ULONG_BITS
+#else
+  #define BITWORDSIZE 64
+#endif
 
 /* This macro is for single-word bit vectors: the debug selector,
 and the first word of the log selector. */
 #define BIT(n) (1UL << (n))
 
 /* And these are for multi-word vectors. */
-#define BITWORD(n) (      (n) / BITWORDSIZE)
-#define BITMASK(n) (1U << (n) % BITWORDSIZE)
+#define BITWORD(n) (       (n) / BITWORDSIZE)
+#define BITMASK(n) (1UL << (n) % BITWORDSIZE)
 
 #define BIT_CLEAR(s,z,n) ((s)[BITWORD(n)] &= ~BITMASK(n))
 #define BIT_SET(s,z,n)   ((s)[BITWORD(n)] |=  BITMASK(n))
@@ -362,9 +366,13 @@ These must match the debug_options table in globals.c .
 
 Exim's code assumes in a number of places that the debug_selector is one
 word, and this is exposed in the local_scan ABI. The D_v and D_local_scan bit
-masks are part of the local_scan API so are #defined in local_scan.h */
+masks are part of the local_scan API so are #defined in local_scan.h .
+
+Thanks to the "one word", debug bits beyond 31 are not available on 32b-int
+systems, and coding must account for that. */
 
-#define DEBUG_BIT(name) Di_##name = IOTA(Di_iota), D_##name = (int)BIT(Di_##name)
+#define DEBUG_BIT(name) Di_##name = IOTA(Di_iota), D_##name = (unsigned long)BIT(Di_##name)
+#define DEBUG_Z_BIT(name) Di_##name = 0, D_##name = 0
 
 enum {
   Di_all        = -1,
@@ -402,8 +410,14 @@ enum {
   DEBUG_BIT(transport),
   DEBUG_BIT(uid),
   DEBUG_BIT(verify),		/* 31 */
+#if EXIM_ULONG_BITS > 32
+  DEBUG_BIT(macro),		/* 33 */
+#else
+  DEBUG_Z_BIT(macro),
+#endif
 };
 
+
 /* Multi-bit debug masks */
 
 #define D_all                        0xffffffff
diff --git a/src/src/os.c b/src/src/os.c
index 4b9d2d1d5..44a53a575 100644
--- a/src/src/os.c
+++ b/src/src/os.c
@@ -12,8 +12,8 @@
 # include <stdio.h>
 # include <time.h>
 #else
-# define IS_DEBUG(x) (debug_selector & (x))
-# define DEBUG(x) if (IS_DEBUG(x))
+# define IS_DEBUG(x) (debug_selector & (x ? x : D_any))
+# define DEBUG(x) if (IS_DEBUG(x))	/* for cppcheck */
 #endif
 
 #ifndef CS
diff --git a/src/src/readconf.c b/src/src/readconf.c
index 356321765..e95a2aed3 100644
--- a/src/src/readconf.c
+++ b/src/src/readconf.c
@@ -786,7 +786,7 @@ macro_create(const uschar * name, const uschar * val, BOOL command_line)
 {
 macro_item * m = store_get(sizeof(macro_item), GET_UNTAINTED);
 
-EARLY_DEBUG(D_any, "%s: '%s' '%s'\n", __FUNCTION__, name, val);
+EARLY_DEBUG(D_macro, "%s: '%s' '%s'\n", __FUNCTION__, name, val);
 m->next = NULL;
 m->command_line = command_line;
 m->namelen = Ustrlen(name);
@@ -979,11 +979,11 @@ if (*s) for (macro_item * m = *s == '_' ? macros : macros_user; m; m = m->next)
     {
     int moveby;
 
-    DEBUG(D_any)
+    DEBUG(D_macro)
       if (f.expansion_test)
 	printf("macro '%s' -> '%s'\n", m->name, m->replacement);
       else
-	EARLY_DEBUG(D_any, "%s: matched '%s' in '%.*s'\n", __FUNCTION__,
+	EARLY_DEBUG(D_macro, "%s: matched '%s' in '%.*s'\n", __FUNCTION__,
 	  m->name, (int) Ustrlen(ss)-1, ss);
 
     /* Expand the buffer if necessary */

